function f = powell1(x)
  %
  % A version of the Powell function which takes a column 4-vector as
  % an argument instead of four distinct arguments.
  %
  if (length(x) == 4)
    f = powell(x(1), x(2), x(3), x(4));
  else
    f = NA;
  end
end
